config/routes.rb
Rails.application.routes.draw do
  root 'users#index'
  resources :users, only: [:index, :create]
end

app/models/table.rb
class Table < ActiveRecord::Base
  has_and_belongs_to_many :users

  def active?
    if (self.start_time - Time.now.localtime) >= 1
      (self.start_time - Time.now.localtime).round
    else
      false
    end
  end

end

app/models/user.rb
class User < ActiveRecord::Base
  has_and_belongs_to_many :tables
  validates :email, presence: :true, format: { with: /.+@.+\..+/i }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/tables_controller.rb
class TablesController < ApplicationController
end

app/controllers/users_controller.rb
class UsersController < ApplicationController

  def index
    @user = session[:user_id].nil? ? User.new : User.includes(:tables).find(session[:user_id])
  end

  def create
    @user = User.find_by_email(user_params[:email]) || User.create(user_params)
    if @user.errors.any?
      flash.notice = @user.errors.full_messages
    else
      attach_tables
      session[:user_id] = @user.id
    end
    redirect_to root_path
  end

  private

  def user_params
    params.permit(:email)
  end

  def attach_tables
    @user.tables.delete_all
    if params[:tables]
      @user.tables << Table.includes(:users).find(params[:tables]).select { |table| table.users.count < 6 }
    end
  end

end

app/helpers/application_helper.rb
module ApplicationHelper

end

app/helpers/tables_helper.rb
module TablesHelper
  def game_start_time(x)
    time = ''
    if !x
      time = 'The game has already started'
    elsif (x < 60)
      time = "#{x} sec"
    elsif ((x >= 60)&&(x < 3600))
      time = "#{x / 60} min and #{x % 60} sec"
    elsif (x >= 3600)
      time = 'It will start in more than an hour'
    end
    time
  end
end

app/helpers/users_helper.rb
module UsersHelper

  def user_tables_by_name
    @user.tables.pluck(:name).sort.join(', ')
  end

end

app/views/layouts/application.html.slim
doctype html
html
  head
    title
      | DM1
    = stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true
    = javascript_include_tag 'application', 'data-turbolinks-track' => true
    = csrf_meta_tags
  body
    = yield

app/views/users/index.html.slim
h1
  | My page
p
  b
    | Hello, 
    = @user.try(:email) || 'Guest'
    | !
- if !@user.tables.empty?
  = 'You\'ll play at tables: ' + user_tables_by_name
- if flash.notice
  #error_explanation
    h3
      = pluralize(flash.notice.size, "error")
      |  prohibited this user from being saved:
    ul
      - flash.notice.each do |msg|
        li
          = msg
    h4
      | Try to write the correct email address below
= form_tag(users_path) do
  = label_tag(:email, 'Email')
  br
  = text_field_tag :email, value = @user.email
  br
  p
    b
      | Current date and time: 
    = Time.now.localtime.to_formatted_s(:short)
  table
    tr
      th
        | Table name
      th
        | Start time
      th
        | Status
      th
        | Number of players
      th
        | Time to start
    - Table.all.sort_by { |t| t.start_time }.each do |t|
      tr
        td
          = check_box_tag "tables[#{t.id}]", t.id, false, name: 'tables[]', disabled: !t.active?, checked: @user.tables.include?(t)
          = label_tag "tables[#{t.id}]", t.name
        td
          = t.start_time.localtime.to_formatted_s(:short)
        td
          = t.active? ? 'Active' : 'Inactive'
        td[align="center"]
          = t.active? ? t.users.count : "-"
        td
          = game_start_time(t.active?)
  br
  = submit_tag('Submit')